﻿'MGE JOY Sketcher v1.0
'Free hand analog joystick sketcher for the TRS-80 Color Computer
'Made by Erico for the Mauricio and Giovani´s modern new joystick

'---VARIABLES
x=32:y=32						:'Current pen position
w=32:z=32						:'Last pen position
a=0								:'Pen location canvas color 
i=1								:'Pen color 0-3 (yellow)
p=0								:'Paper color 0-3 (green)
pm=0							:'Pen mode 0-1 raised/lowered (raised)
t=0								:'Pen raised blinking timer
m=0								:'Color mode 0-1
h=1								:'Display HUD

'---BOOT
boot:
SCREEN #7						:'Set 64x64 resolution - color mode 0
p01 := LOAD IMAGE("TITLE.png")	:'Load title/instruction screen
PUT IMAGE p01 AT 0,0			:'Display it
WAIT FIRE						:'Press key or button to start
BELL 6,800
WAIT 400 MS						:'Wait a little bit
CLS								:'Clear the screen
pm=0							:'Raise pen

'--------------------------------------------------------------------LOOP
DO
tim=TIMER

x=JOYX(0):y=JOYY(0)	:'Get analog joystick values(-32 to 32) for each axis
x=x+31:y=y+31		:'Fix value ranges 0 to 63 for each axis

'---RAISE OR LOWER PEN
IF JFIRE(0)=TRUE THEN:						:'Is joystick button pressed?
	IF pm=0 THEN:
		pm=1:BELL 40,300:BELL 22,300		:'Lower pen and make some noise! 
	ELSE:
		pm=0:BELL 32,300:BELL 50,300		:'Raise pen and make some noise!
	ENDIF
	a=i										:'Set pen color to canvas color
	WAIT 100 MS								:'Wait a little bit
ENDIF

'---MOVE AND DRAW WITH PEN
IF pm=0 THEN:				:'If the pen is raised
	IF x<>w OR y<>z THEN:		:'Is new location different than the last one?
		PEN a:POINT AT(w,z)		:'Erase last location with recorded canvas color
		a=POINT(x,y)			:'Record current pen location canvas color
		PEN i					:'Set pen color
		IF a=i THEN:			:'If color equal to background choose another
			PEN a+1
			IF a=3 THEN PEN 0	:'Use 0 if pen color equals canvas color	
		ENDIF
		POINT AT(x,y)			:'Plot current pen
	ELSE:							:'New location same as last
		IF t=0 THEN:				:'Blink pen
			PEN i:t=1				:'Set first pen color 
		ELSE
			PEN a					:'Set pen second color
			IF a=i THEN:			:'If color equal to background choose another
				PEN a+1
				IF a=3 THEN PEN 0	:'Use 0 if pen color equals canvas color
			ENDIF
			t=0						:'reset blink timer
		ENDIF
		POINT AT(x,y)				:'Plot pen
	ENDIF
ELSE:						:'If the pen is lowered
	LINE w,z TO x,y,i			:'Draw line between current and last locations
ENDIF
w=x:z=y						:'Update last pen position to current one

'---USER INTERFACE
If KEY PRESSED(KEY I) THEN:						:'Press I to cicle pen color	
	i=i+1:BELL 22,600
	IF i=4 THEN i=0
ENDIF
If KEY PRESSED(KEY P) THEN:						:'Press P to cicle paper color
	p=p+1:BELL 22,600
	IF p=4 THEN p=0
ENDIF
If KEY PRESSED(KEY C) THEN:						:'Press C to clear screen
	LOCATE 0,0: PAPER p
	PRINT"                                ";
	PRINT"                                 ";
	a=POINT(x,y)
	BELL 22,600
ENDIF
If KEY PRESSED(KEY R) THEN:						:'Press R to reset to title
	BELL 12,600
	GOTO boot
ENDIF
IF KEY PRESSED(KEY T) THEN:						:'Press T for HUD on/off
	IF h=0 THEN:
		h=1
	ELSE:
		h=0:LOCATE 0,0
		PRINT "        "; 
	ENDIF
	BELL 22,600
ENDIF

'---HUD
IF h=1 THEN:
	LOCATE 0,0:PAPER 2:PEN 1					:'Print raised/lowered pen icon
	IF pm=0 THEN:PRINT"^";:ELSE:PRINT"*";:ENDIF
	LOCATE 1,0:PAPER 0:PEN 3:PRINT x;" ";		:'Print pen x location
	LOCATE 4,0:PRINT y;" ";						:'Print pen y location
	LOCATE 7,0:PAPER p:PEN i:PRINT"I";			:'Print ink and paper icon
ENDIF

LOOP